﻿//InDesign CS3/4
//alexey-denisjuk@ya.ru, 2009
str = 'Скрипт маскирует белым фоном на текущем развороте всё,\r кроме области под выделеным фреймом\r и экспортирует страницу (разворот) в .jpg (72, low) на рабочий стол';
if(!confirm(str))
	exit();
var doc = app.activeDocument;
var box = app.selection[0];
if(!box || (box.constructor.name != 'Rectangle' && box.constructor.name != 'TextFrame')){
	alert('Нужно выделить фрейм или прямоугольник.');
	exit();
	}

var spread = getSpread(box);
var spreadSize = [spread.pages.lastItem().bounds[2], spread.pages.lastItem().bounds[3]];
var selectLayer = doc.activeLayer;
doc.activeLayer = doc.layers.firstItem();

boxCopy = spread.pages.lastItem().rectangles.add({visibleBounds: box.visibleBounds, strokeWeight: box.strokeWeight});
fgRec = spread.pages.lastItem().rectangles.add({visibleBounds: [0, 0, spreadSize[0], spreadSize[1]], strokeWeight: 0, fillColor: 'Paper'});
resRec = boxCopy.subtractPath(fgRec);

file = File(Folder.desktop + '/' + doc.name.replace(/^(.+)\..+$/, '$1') + '_p' + resRec.parent.name + '.jpg');
with(app.jpegExportPreferences){
	exportingSpread = (spread.pages.length > 1 && (spreadSize[1]/2 > box.visibleBounds[1] && spreadSize[1]/2 < box.visibleBounds[3])) ? true : false;
	resolution = 72;
	jpegQuality = JPEGOptionsQuality.low;
	jpegExportRange = ExportRangeOrAllPages.EXPORT_RANGE;
	pageString = resRec.parent.name;
	}
doc.exportFile(ExportFormat.jpg, file, false);

resRec.remove();
doc.activeLayer = selectLayer;

//file.execute();

///===================================================
function getSpread(box){
	var spread;
	switch(box.parent.constructor.name){
		case 'Page':
		spread = box.parent.parent;
		break;
		case 'Character':
		spread = box.parent.parentTextFrames[0].parent.parent;
		break;
		case 'Spread':
		spread = box.parent;
		break;
		case 'Group':
		spread = getSpread(box.parent);
		break;
		default:
		alert('Ошибка:\r box.parent.constructor.name:\r ' + box.parent.constructor.name);
		exit();
		}
	return spread;
	}